Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(revision 3287)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(working copy)
@@ -599,318 +908,633 @@
 					editor.selectNodeContents(td);
 				}
 			}
+			this.reStyleTable(table);
 			break;
-				// CREATION AND PROPERTIES
-			case "InsertTable":
-				this.dialogInsertTable();
-				break;
-			case "TO-table-prop":
-				this.dialogTableProperties();
-				break;
-			case "TO-row-prop":
-				this.dialogRowCellProperties(false);
-				break;
-			case "TO-cell-prop":
-				this.dialogRowCellProperties(true);
-				break;
-			case "TO-toggle-borders":
-				this.toggleBorders();
-				break;
-			default:
-				alert("Button [" + buttonId + "] not yet implemented");
+			
+			// CREATION AND PROPERTIES
+		    case "InsertTable":
+		    case "TO-table-prop":
+			this.dialogTableProperties(buttonId);
+			break;
+		    case "TO-table-restyle":
+			this.reStyleTable(this.getClosest("table"));
+			break;
+		    case "TO-row-prop":
+			this.dialogRowCellProperties(false, false);
+			break;
+		    case "TO-col-prop":
+			this.dialogRowCellProperties(true, true);
+			break;
+		    case "TO-cell-prop":
+			this.dialogRowCellProperties(true, false);
+			break;
+		    case "TO-toggle-borders":
+			this.toggleBorders();
+			break;
+		    default:
+			alert("Button [" + buttonId + "] not yet implemented");
 		}
 	},
 	
 	/*
-	 * Open insert table request
+	 * Returns an array of all cells in the column containing the given cell
+	 *
+	 * @param	object		cell: the cell serving as reference point for the column
+	 *
+	 * @return	array		the array of cells of the column
 	 */
-	dialogInsertTable : function () {
-		this.dialog = this.openDialog("InsertTable", this.makeUrlFromPopupName("insert_table"), "insertTable", null, {width:520, height:230});
-		return false;
+	getColumnCells : function (cell) {
+		var cells = new Array();
+		var index = cell.cellIndex;
+		var table = cell.parentNode.parentNode.parentNode;
+		for (var j = this.tableParts.length; --j >= 0;) {
+			var tablePart = table.getElementsByTagName(this.tableParts[j])[0];
+			if (tablePart) {
+				var rows = tablePart.rows;
+				for (var i = rows.length; --i >= 0;) {
+					if(rows[i].cells.length > index) {
+						cells.push(rows[i].cells[index]);
+					}
+				}
+			}
+		}
+		return cells;
 	},
 	
 	/*
-	* Get the insert table action function
-	*/
-	insertTable : function(param) {
-		var editor = this.editor;
-		if (!param) return false;
-		var doc = editor._doc;
-		var table = doc.createElement("table");
-		for (var field in param) {
-			if (param.hasOwnProperty(field)) {
-				var value = param[field];
-				if (value) {
-					switch (field) {
-						case "f_width"   : 
-							if(value != "") {
-								table.style.width = parseInt(value) + param["f_unit"];
-								break;
-							}
-						case "f_align"   :
-							table.style.textAlign = value;
-							break;
-						case "f_border"  :
-							if(value != "") {
-								table.style.borderWidth	 = parseInt(value)+"px";
-								table.style.borderStyle = "solid";
-							}
-							break;
-						case "f_spacing" :
-							if(value != "") {
-								table.cellSpacing = parseInt(value);
-								break;
-							}
-						case "f_padding" :
-							if(value != "") {
-								table.cellPadding = parseInt(value);
-								break;
-							}
-						case "f_float"   :
-							if (HTMLArea.is_ie) {
-								table.style.styleFloat = ((value != "not set") ? value : "");
-							} else {
-								table.style.cssFloat = ((value != "not set") ? value : "");
-							}
-							break;
+	 * Toggles the display of borders on tables and table cells
+	 *
+	 * @param	boolean		forceBorders: if set, borders are displayed whatever the current state
+	 *
+	 * @return	void
+	 */
+	toggleBorders : function (forceBorders) {
+		var body = this.editor._doc.body;
+		if (!HTMLArea._hasClass(body, 'htmlarea-showtableborders')) {
+			HTMLArea._addClass(body,'htmlarea-showtableborders');
+		} else if (!forceBorders) {
+			HTMLArea._removeClass(body,'htmlarea-showtableborders');
+		}
+			// The only way to get Firefox to show these borders...
+		if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) this.editor.setMode("wysiwyg");
+	},
+	
+	/*
+	 * Applies to rows/cells the alternating classes of an alternating style scheme
+	 *
+	 * @param	object		table: the table to be re-styled
+	 *
+	 * @return	void
+	 */
+	reStyleTable : function (table) {
+		if (table) {
+			if (this.classesUrl && typeof(HTMLArea.classesAlternating) === "undefined") {
+				this.getJavascriptFile(this.classesUrl);
+			}
+			var classNames = table.className.trim().split(" ");
+			for (var i = classNames.length; --i >= 0;) {
+				var classConfiguration = HTMLArea.classesAlternating[classNames[i]];
+				if (classConfiguration && classConfiguration.rows) {
+					if (classConfiguration.rows.oddClass && classConfiguration.rows.evenClass) {
+						this.alternateRows(table, classConfiguration);
 					}
 				}
+				if (classConfiguration && classConfiguration.columns) {
+					if (classConfiguration.columns.oddClass && classConfiguration.columns.evenClass) {
+						this.alternateColumns(table, classConfiguration);
+					}
+				}
 			}
 		}
-		var cellwidth = 0;
-		if(param.f_fixed) cellwidth = Math.floor(100 / parseInt(param.f_cols));
-		var tbody = doc.createElement("tbody");
-		table.appendChild(tbody);
-		for (var i = param["f_rows"]; i > 0; i--) {
-			var tr = doc.createElement("tr");
-			tbody.appendChild(tr);
-			for (var j = param["f_cols"]; j > 0; j--) {
-				var td = doc.createElement("td");
-				if (cellwidth) td.style.width = cellwidth + "%";
-				if (HTMLArea.is_opera) { td.innerHTML = '&nbsp;'; }
-				tr.appendChild(td);
+	},
+	
+	/*
+	 * Removes from rows/cells the alternating classes of an alternating style scheme
+	 *
+	 * @param	object		table: the table to be re-styled
+	 * @param	string		removeClass: the name of the class that identifies the alternating style scheme
+	 *
+	 * @return	void
+	 */
+	removeAlternatingClasses : function (table, removeClass) {
+		if (table) {
+			if (this.classesUrl && typeof(HTMLArea.classesAlternating) === "undefined") {
+				this.getJavascriptFile(this.classesUrl);
 			}
+			var classConfiguration = HTMLArea.classesAlternating[removeClass];
+			if (classConfiguration) {
+				if (classConfiguration.rows && classConfiguration.rows.oddClass && classConfiguration.rows.evenClass) {
+					this.alternateRows(table, classConfiguration, true);
+				}
+				if (classConfiguration.columns && classConfiguration.columns.oddClass && classConfiguration.columns.evenClass) {
+					this.alternateColumns(table, classConfiguration, true);
+				}
+			}
 		}
-		editor.focusEditor();
-		editor.insertNodeAtSelection(table);
-		if (this.buttonsConfiguration.toggleborders && this.buttonsConfiguration.toggleborders.setOnTableCreation) {
-			this.toggleBorders();
+	},
+	
+	/*
+	 * Applies/removes the alternating classes of an alternating rows style scheme
+	 *
+	 * @param	object		table: the table to be re-styled
+	 * @param	object		classConfifuration: the alternating sub-array of the configuration of the class
+	 * @param	boolean		remove: if true, the classes are removed
+	 *
+	 * @return	void
+	 */
+	alternateRows : function (table, classConfiguration, remove) {
+		var oddClass = { tbody : classConfiguration.rows.oddClass, thead : classConfiguration.rows.oddHeaderClass };
+		var evenClass = { tbody : classConfiguration.rows.evenClass, thead : classConfiguration.rows.evenHeaderClass };
+		var startAt = classConfiguration.rows.startAt ? parseInt(classConfiguration.rows.startAt) : 0;
+		startAt = remove ? 0 : startAt;
+		var rows = table.rows, type, odd, even;
+			// Loop through the rows
+		for (var i = startAt, n = rows.length; i < n; i++) {
+			var row = rows[i];
+			type = (row.parentNode.nodeName.toLowerCase() == "thead") ? "thead" : "tbody";
+			odd = oddClass[type];
+			even = evenClass[type];
+			if (remove) {
+				HTMLArea._removeClass(row, odd);
+				HTMLArea._removeClass(row, even);
+				// Check if i is even, and apply classes for both possible results
+			} else if (odd && even) {
+				if ((i % 2) == 0) {
+					if (HTMLArea._hasClass(row, odd)) {
+						HTMLArea._removeClass(row, odd);
+					}
+					HTMLArea._addClass(row, even);
+				} else {
+					if (HTMLArea._hasClass(row, even)) {
+						HTMLArea._removeClass(row, even);
+					}
+					HTMLArea._addClass(row, odd);
+				}
+			}
 		}
-		return true;
 	},
 	
-	toggleBorders : function () {
-		var tables = this.editor._doc.getElementsByTagName("table");
-		if (tables.length != 0) {
-			this.editor.borders = true;
-			for (var ix=0; ix < tables.length; ix++) this.editor.borders = this.editor.borders && /htmlarea-showtableborders/.test(tables[ix].className);
-			for (ix=0; ix < tables.length; ix++) {
-				if (!this.editor.borders) HTMLArea._addClass(tables[ix],'htmlarea-showtableborders');
-					else HTMLArea._removeClass(tables[ix],'htmlarea-showtableborders');
+	/*
+	 * Applies/removes the alternating classes of an alternating columns style scheme
+	 *
+	 * @param	object		table: the table to be re-styled
+	 * @param	object		classConfifuration: the alternating sub-array of the configuration of the class
+	 * @param	boolean		remove: if true, the classes are removed
+	 *
+	 * @return	void
+	 */
+	alternateColumns : function (table, classConfiguration, remove) {
+		var oddClass = { td : classConfiguration.columns.oddClass, th : classConfiguration.columns.oddHeaderClass };
+		var evenClass = { td : classConfiguration.columns.evenClass, th : classConfiguration.columns.evenHeaderClass };
+		var startAt = classConfiguration.columns.startAt ? parseInt(classConfiguration.columns.startAt) : 0;
+		startAt = remove ? 0 : startAt;
+		var rows = table.rows, type, odd, even;
+			// Loop through the rows of the table
+		for (var i = rows.length; --i >= 0;) {
+				// Loop through the cells
+			var cells = rows[i].cells;
+			for (var j = startAt, n = cells.length; j < n; j++) {
+				var cell = cells[j];
+				type = cell.nodeName.toLowerCase();
+				odd = oddClass[type];
+				even = evenClass[type];
+				if (remove) {
+					if (odd) HTMLArea._removeClass(cell, odd);
+					if (even) HTMLArea._removeClass(cell, even);
+				} else if (odd && even) {
+						// Check if j+startAt is even, and apply classes for both possible results
+					if ((j % 2) == 0) {
+						if (HTMLArea._hasClass(cell, odd)) {
+							HTMLArea._removeClass(cell, odd);
+						}
+						HTMLArea._addClass(cell, even);
+					} else{
+						if (HTMLArea._hasClass(cell, even)) {
+							HTMLArea._removeClass(cell, even);
+						}
+						HTMLArea._addClass(cell, odd);
+					}
+				}
 			}
 		}
-			// The only way to get Firefox to show these borders...
-		if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) this.editor.setMode("wysiwyg");
-	}
-});
-
-/*
- * Set the language file for the plugin
- */
-TableOperations.I18N = TableOperations_langArray;
-
-/*
- * Initialize the table properties dialog
- */
-TableOperations.tablePropertiesInit = function(table) {
-	return (function (dialog) {
-		var doc = dialog.doc;
-		var content = dialog.content;
-		var i18n = TableOperations.I18N;
-		TableOperations.buildTitle(doc, i18n, content, "Table Properties");
-		TableOperations.buildDescriptionFieldset(doc, table, i18n, content);
-		var obj = dialog.editor.config.customSelects.BlockStyle ? dialog.editor.plugins.BlockStyle.instance : dialog.editor.config.customSelects["DynamicCSS-class"];
-		if (obj && (obj.loaded || obj.cssLoaded)) TableOperations.buildStylingFieldset(doc, table, i18n, content, obj.cssArray);
-		if (!dialog.editor.config.disableLayoutFieldsetInTableOperations) TableOperations.buildLayoutFieldset(doc, table, i18n, content);
-		if (!dialog.editor.config.disableAlignmentFieldsetInTableOperations) TableOperations.buildAlignmentFieldset(doc, table, i18n, content, "floating");
-		if (!dialog.editor.config.disableSpacingFieldsetInTableOperations) TableOperations.buildSpacingFieldset(doc, table, i18n, content);
-		if (!dialog.editor.config.disableBordersFieldsetInTableOperations) TableOperations.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, table, i18n, content);
-		if (!dialog.editor.config.disableColorFieldsetInTableOperations) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, table, i18n, content);
-		dialog.modal = true;
-		dialog.addButtons("ok", "cancel");
-		dialog.showAtElement();
-	});
-};
-
-/*
- * Update the table properties and close the dialog
- */
-TableOperations.tablePropertiesUpdate = function(table) {
-	return (function (dialog,params) {
-		dialog.editor.focusEditor();
-		TableOperations.processStyle(params, table);
-		table.removeAttribute("border");
-		for (var i in params) {
-			var val = params[i];
-			switch (i) {
-			    case "f_caption":
-				if (/\S/.test(val)) {
-					// contains non white-space characters
-					var caption = table.getElementsByTagName("caption")[0];
-					if (!caption) {
-						caption = dialog.editor._doc.createElement("caption");
-						table.insertBefore(caption, table.firstChild);
+	},
+	
+	/*
+	 * This function sets the headers cells on the table (top, left, both or none)
+	 *
+	 * @param	object		table: the table being edited
+	 * @param	object		params: the field values entered in the form
+	 *
+	 * @return	object		the modified table
+	 */
+	setHeaders : function (table, params) {
+		var headers = params.f_headers;
+		var doc = this.editor._doc;
+		var tbody = table.tBodies[0];
+		var thead = table.tHead;
+		if (thead && !thead.rows.length && !tbody.rows.length) {
+			 // Table is degenerate
+			return table;
+		}
+		if (headers == "top") {
+			if (!thead) {
+				var thead = doc.createElement("thead");
+				thead = table.insertBefore(thead, tbody);
+			}
+			if (!thead.rows.length) {
+				var firstRow = thead.appendChild(tbody.rows[0]);
+			} else {
+				var firstRow = thead.rows[0];
+			}
+			HTMLArea._removeClass(firstRow, this.useHeaderClass);
+		} else {
+			if (thead) {
+				var rows = thead.rows;
+				if (rows.length) {
+					for (var i = rows.length; --i >= 0 ;) {
+						this.remapRowCells(rows[i], "td");
+						if (tbody.rows.length) {
+							tbody.insertBefore(rows[i], tbody.rows[0]);
+						} else {
+							tbody.appendChild(rows[i]);
+						}
 					}
-					caption.innerHTML = val;
-				} else {
-					// search for caption and delete it if found
-					var caption = table.getElementsByTagName("caption")[0];
-					if (caption) caption.parentNode.removeChild(caption);
 				}
-				break;
-			    case "f_summary":
-				table.summary = val;
-				break;
-			    case "f_width":
-				table.style.width = ("" + val) + params.f_unit;
-				break;
-			    case "f_align":
-				table.align = val;
-				break;
-			    case "f_spacing":
-				table.cellSpacing = val;
-				break;
-			    case "f_padding":
-				table.cellPadding = val;
-				break;
-			    case "f_frames":
-				table.frame = (val != "not set") ? val : "";
-				break;
-			    case "f_rules":
-				if (val != "not set") table.rules = val;
-			    		else table.removeAttribute("rules");
-				break;
-			    case "f_class":
-			    case "f_class_tbody":
-			    case "f_class_thead":
-			    case "f_class_tfoot":
-			    	var tpart = table;
-			    	if (i.length > 7) tpart = table.getElementsByTagName(i.substring(8,13))[0];
-				var cls = tpart.className.trim().split(" ");
-				for (var j = cls.length;j > 0;) {
-					if (!HTMLArea.reservedClassNames.test(cls[--j])) HTMLArea._removeClass(tpart,cls[j]);
+				table.removeChild(thead);
+			}
+		}
+		if (headers == "both") {
+			var firstRow = tbody.rows[0];
+			HTMLArea._addClass(firstRow, this.useHeaderClass);
+		} else if (headers != "top") {
+			var firstRow = tbody.rows[0];
+			HTMLArea._removeClass(firstRow, this.useHeaderClass);
+			this.remapRowCells(firstRow, "td");
+		}
+		if (headers == "top" || headers == "both") {
+			this.remapRowCells(firstRow, "th");
+		}
+		if (headers == "left") {
+			var firstRow = tbody.rows[0];
+		}
+		if (headers == "left" || headers == "both") {
+			var rows = tbody.rows;
+			for (var i = rows.length; --i >= 0 ;) {
+				if (i || rows[i] == firstRow) {
+					if (rows[i].cells[0].nodeName.toLowerCase() != "th") {
+						var th = this.remapCell(rows[i].cells[0], "th");
+						th.scope = "row";
+					}
 				}
-				if (val != 'none') HTMLArea._addClass(tpart,val);
-				break;
 			}
+		} else {
+			var rows = tbody.rows;
+			for (var i = rows.length; --i >= 0 ;) {
+				if (rows[i].cells[0].nodeName.toLowerCase() != "td") {
+					rows[i].cells[0].scope = "";
+					var td = this.remapCell(rows[i].cells[0], "td");
+				}
+			}
 		}
-		dialog.editor.focusEditor();
-		dialog.editor.updateToolbar();
-	});
-};
-
-/*
- * Initialize the row/cell properties dialog
- */
-TableOperations.rowCellPropertiesInit = function(element,cell) {
-	return (function (dialog) {
-		var doc = dialog.doc;
-		var content = dialog.content;
-		var i18n = TableOperations.I18N;
-		TableOperations.buildTitle(doc, i18n, content, (cell ? "Cell Properties" : "Row Properties"));
-		if (cell) TableOperations.buildCellTypeFieldset(dialog.dialogWindow, doc, dialog.editor, element, i18n, content);
-			else TableOperations.buildRowGroupFieldset(dialog.dialogWindow, doc, dialog.editor, element, i18n, content);
-		var obj = dialog.editor.config.customSelects.BlockStyle ? dialog.editor.plugins.BlockStyle.instance : dialog.editor.config.customSelects["DynamicCSS-class"];
-		if (obj && (obj.loaded || obj.cssLoaded))  TableOperations.buildStylingFieldset(doc, element, i18n, content, obj.cssArray);
-			else TableOperations.insertSpace(doc, content);
-		if (!dialog.editor.config.disableLayoutFieldsetInTableOperations) TableOperations.buildLayoutFieldset(doc, element, i18n, content, "floating");
-		if (!dialog.editor.config.disableAlignmentFieldsetInTableOperations) TableOperations.buildAlignmentFieldset(doc, element, i18n, content);
-		if (!dialog.editor.config.disableBordersFieldsetInTableOperations) TableOperations.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, element, i18n, content);
-		if (!dialog.editor.config.disableColorFieldsetInTableOperations) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, element, i18n, content);
-		dialog.modal = true;
-		dialog.addButtons("ok", "cancel");
-		dialog.showAtElement();
-	});
-};
-
-/*
- * Update the row/cell properties and close the dialog
- */
-TableOperations.rowCellPropertiesUpdate = function(element) {
-	return (function (dialog,params) {
-		dialog.editor.focusEditor();
-		TableOperations.processStyle(params, element);
-		var convertCellType = false;
+		this.reStyleTable(table);
+		return table;
+	},
+	
+	/*
+	 * This function remaps the given cell to the specified node name
+	 */
+	remapCell : function(element, nodeName) {
+		var newCell = this.editor.convertNode(element, nodeName);
+		var attributes = element.attributes, attributeName, attributeValue;
+		for (var i = attributes.length; --i >= 0;) {
+			attributeName = attributes.item(i).nodeName;
+			attributeValue = element.getAttribute(attributeName);
+			if (attributeValue) newCell.setAttribute(attributeName, attributeValue);
+		}
+			// In IE, the above fails to update the classname and style attributes.
+		if (HTMLArea.is_ie) {
+			if (element.style.cssText) {
+				newCell.style.cssText = element.style.cssText;
+			}
+			if (element.className) {
+				newCell.setAttribute("className", element.className);
+			} else {
+				newCell.removeAttribute("className");
+			}
+		}
+		
+		if (this.tags && this.tags[nodeName] && this.tags[nodeName].allowedClasses) {
+			if (newCell.className && /\S/.test(newCell.className)) {
+				var allowedClasses = new RegExp( "^(" + this.tags[nodeName].allowedClasses.trim().split(",").join("|") + ")$");
+				var classNames = newCell.className.trim().split(" ");
+				for (var i = classNames.length; --i >= 0;) {
+					if (!allowedClasses.test(classNames[i])) {
+						HTMLArea._removeClass(newCell, classNames[i]);
+					}
+				}
+			}
+		}
+		return newCell;
+	},
+	
+	remapRowCells : function (row, toType) {
+		var cells = row.cells;
+		if (toType === "th") {
+			for (var i = cells.length; --i >= 0 ;) {
+				if (cells[i].nodeName.toLowerCase() != "th") {
+					var th = this.remapCell(cells[i], "th");
+					th.scope = "col";
+				}
+			}
+		} else {
+			for (var i = cells.length; --i >= 0 ;) {
+				if (cells[i].nodeName.toLowerCase() != "td") {
+					var td = this.remapCell(cells[i], "td");
+					td.scope = "";
+				}
+			}
+		}
+	},
+	
+	/*
+	 * This function applies the style properties found in params to the given element
+	 *
+	 * @param	object		element: the element
+	 * @param	object		params: the properties
+	 *
+	 * @return	object		the modified element
+	 */
+	processStyle : function (element, params) {
+		var style = element.style;
+		if (HTMLArea.is_ie) {
+			style.styleFloat = "";
+		} else {
+			style.cssFloat = "";
+		}
+		style.textAlign = "";
 		for (var i in params) {
-			var val = params[i];
-			switch (i) {
-			    case "f_scope":
-			    	if (val != "not set") element.scope = val;
-			    		else element.removeAttribute('scope');
-				break;
-			    case "f_cell_type":
-			    		// Set all cell attributes before cloning it with a new tag
-			    	if (val != element.tagName.toLowerCase()) {
-					var newCellType = val;
-					convertCellType = true;
+			if (params.hasOwnProperty(i)) {
+				var val = params[i];
+				switch (i) {
+				    case "f_st_backgroundColor":
+					style.backgroundColor = val;
+					break;
+				    case "f_st_color":
+					style.color = val;
+					break;
+				    case "f_st_backgroundImage":
+					if (/\S/.test(val)) {
+						style.backgroundImage = "url(" + val + ")";
+					} else {
+						style.backgroundImage = "";
+					}
+					break;
+				    case "f_st_borderWidth":
+					if (/\S/.test(val)) {
+						style.borderWidth = val + "px";
+					} else {
+						style.borderWidth = "";
+					}
+					if (params.f_st_borderStyle == "none") style.borderWidth = "0px";
+					if (params.f_st_borderStyle == "not set") style.borderWidth = "";
+					break;
+				    case "f_st_borderStyle":
+					style.borderStyle = (val != "not set") ? val : "";
+					break;
+				    case "f_st_borderColor":
+					style.borderColor = val;
+					break;
+				    case "f_st_borderCollapse":
+					style.borderCollapse = val ? "collapse" : "";
+					break;
+				    case "f_st_width":
+					if (/\S/.test(val)) {
+						style.width = val + params.f_st_widthUnit;
+					} else {
+						style.width = "";
+					}
+					break;
+				    case "f_st_height":
+					if (/\S/.test(val)) {
+						style.height = val + params.f_st_heightUnit;
+					} else {
+						style.height = "";
+					}
+					break;
+				    case "f_st_textAlign":
+					style.textAlign = (val != "not set") ? val : "";
+					break;
+				    case "f_st_vertAlign":
+					style.verticalAlign = (val != "not set") ? val : "";
+					break;
 				}
-				break;
-			    case "f_rowgroup":
-			   	var section = element.parentNode;
-				var tagName = section.tagName.toLowerCase();
-				if (val != tagName) {
-					var table = section.parentNode;
-					var newSection = table.getElementsByTagName(val)[0];
-					if (!newSection) var newSection = table.insertBefore(dialog.editor._doc.createElement(val), table.getElementsByTagName("tbody")[0]);
-					if (tagName == "thead" && val == "tbody") var newElement = newSection.insertBefore(element, newSection.firstChild);
-						else var newElement = newSection.appendChild(element);
-					if (!section.hasChildNodes()) table.removeChild(section);
+			}
+		}
+		return element;
+	},
+	
+	/*
+	 * This function creates a Size and Headers fieldset to be added to the form
+	 *
+	 * @param	object		doc: the dialog document
+	 * @param	object		table: the table being edited
+	 * @param	object		content: the content div of the dialog window
+	 *
+	 * @return	void
+	 */
+	buildSizeAndHeadersFieldset : function (doc, table, content, fieldsetClass) {
+		var fieldset = doc.createElement("fieldset");
+		if (fieldsetClass) fieldset.className = fieldsetClass;
+		if (!table) {
+			TableOperations.insertLegend(doc, fieldset, "Size and Headers");
+			TableOperations.buildInput(doc, fieldset, "f_rows", "Rows:", "Number of rows", "", "5", ((this.properties && this.properties.numberOfRows && this.properties.numberOfRows.defaultValue) ? this.properties.numberOfRows.defaultValue : "2"), "fr");
+			TableOperations.buildInput(doc, fieldset, "f_cols", "Cols:", "Number of columns", "", "5", ((this.properties && this.properties.numberOfColumns && this.properties.numberOfColumns.defaultValue) ? this.properties.numberOfColumns.defaultValue : "4"));
+		} else {
+			TableOperations.insertLegend(doc, fieldset, "Headers");
+		}
+		if (this.removedProperties.indexOf("headers") == -1) {
+			var ul = doc.createElement("ul");
+			fieldset.appendChild(ul);
+			var li = doc.createElement("li");
+			ul.appendChild(li);
+			if (!table) {
+				var selected = (this.properties && this.properties.headers && this.properties.headers.defaultValue) ? this.properties.headers.defaultValue : "top";
+			} else {
+				var selected = "none";
+				var thead = table.getElementsByTagName("thead");
+				var tbody = table.getElementsByTagName("tbody");
+				if (thead.length && thead[0].rows.length) {
+					selected = "top";
+				} else if (tbody.length && tbody[0].rows.length) {
+					if (HTMLArea._hasClass(tbody[0].rows[0], this.useHeaderClass)) {
+						selected = "both";
+					} else if (tbody[0].rows[0].cells.length && tbody[0].rows[0].cells[0].nodeName.toLowerCase() == "th") {
+						selected = "left";
+					}
 				}
+			}
+			var selectHeaders = TableOperations.buildSelectField(doc, li, "f_headers", "Headers:", "fr", "floating", "Table headers", ["No header cells", "Header cells on top", "Header cells on left", "Header cells on top and left"], ["none", "top", "left", "both"],  new RegExp((selected ? selected : "top"), "i"));
+			this.removeOptions(selectHeaders, "headers");
+		}
+		TableOperations.insertSpace(doc, fieldset);
+		content.appendChild(fieldset);
+	},
+	
+	buildLayoutFieldset : function(doc, el, content, fieldsetClass) {
+		var select, selected;
+		var fieldset = doc.createElement("fieldset");
+		if (fieldsetClass) fieldset.className = fieldsetClass;
+		TableOperations.insertLegend(doc, fieldset, "Layout");
+		var f_st_width = el ? TableOperations.getLength(el.style.width) : ((this.properties && this.properties.width && this.properties.width.defaultValue) ? this.properties.width.defaultValue : "");
+		var f_st_height = el ? TableOperations.getLength(el.style.height) : ((this.properties && this.properties.height && this.properties.height.defaultValue) ? this.properties.height.defaultValue : "");
+		var selectedWidthUnit = el ? (/%/.test(el.style.width) ? '%' : (/px/.test(el.style.width) ? 'px' : 'em')) : ((this.properties && this.properties.widthUnit &&this.properties.widthUnit.defaultValue) ? this.properties.widthUnit.defaultValue : "%");
+		var selectedHeightUnit = el ? (/%/.test(el.style.height) ? '%' : (/px/.test(el.style.height) ? 'px' : 'em')) : ((this.properties && this.properties.heightUnit &&this.properties.heightUnit.defaultValue) ? this.properties.heightUnit.defaultValue : "%");
+		var nodeName = el ? el.nodeName.toLowerCase() : "table";
+		var ul = doc.createElement("ul");
+		fieldset.appendChild(ul);
+		switch(nodeName) {
+			case "table" :
+				var widthTitle = "Table width";
+				var heightTitle = "Table height";
 				break;
-			    case "f_char":
-				element.ch = val;
+			case "tr" :
+				var widthTitle = "Row width";
+				var heightTitle = "Row height";
 				break;
-			    case "f_class":
-				var cls = element.className.trim().split(" ");
-				for (var j = cls.length;j > 0;) {
-					if (!HTMLArea.reservedClassNames.test(cls[--j])) HTMLArea._removeClass(element,cls[j]);
+			case "td" :
+			case "th" :
+				var widthTitle = "Cell width";
+				var heightTitle = "Cell height";
+		}
+		if (this.removedProperties.indexOf("width") == -1) {
+			var li = doc.createElement("li");
+			ul.appendChild(li);
+			TableOperations.buildInput(doc, li, "f_st_width", "Width:", widthTitle, "", "5", f_st_width, "fr");
+			select = TableOperations.buildSelectField(doc, li, "f_st_widthUnit", "", "", "", "Width unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_width ? selectedWidthUnit : "%"), "i"));
+			this.removeOptions(select, "widthUnit");
+		}
+		if (this.removedProperties.indexOf("height") == -1) {
+			var li = doc.createElement("li");
+			ul.appendChild(li);
+			TableOperations.buildInput(doc, li, "f_st_height", "Height:", heightTitle, "", "5", f_st_height, "fr");
+			select = TableOperations.buildSelectField(doc, li, "f_st_heightUnit", "", "", "", "Height unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_height ? selectedHeightUnit : "%"), "i"));
+			this.removeOptions(select, "heightUnit");
+		}
+		if (nodeName == "table" && this.removedProperties.indexOf("float") == -1) {
+			selected = el ? (HTMLArea._hasClass(el, this.floatLeft) ? "left" : (HTMLArea._hasClass(el, this.floatRight) ? "right" : "not set")) : this.floatDefault;
+			select = TableOperations.buildSelectField(doc, li, "f_st_float", "Float:", "", "", "Specifies where the table should float", ["Not set", "Left", "Right"], ["not set", "left", "right"], new RegExp((selected ? selected : "not set"), "i"));
+			this.removeOptions(select, "float");
+		}
+		content.appendChild(fieldset);
+	},
+	
+	buildAlignmentFieldset : function (doc, el, content, fieldsetClass) {
+		var select;
+		var nodeName = el ? el.nodeName.toLowerCase() : "table";
+		var fieldset = doc.createElement("fieldset");
+		if (fieldsetClass) fieldset.className = fieldsetClass;
+		TableOperations.insertLegend(doc, fieldset, "Alignment");
+		var options = ["Not set", "Left", "Center", "Right", "Justify"];
+		var values = ["not set", "left", "center", "right", "justify"];
+		var selected = "";
+		if (el && this.editor.plugins.BlockElements) {
+			var blockElements = this.editor.plugins.BlockElements.instance;
+			for (var value in this.convertAlignment) {
+				if (this.convertAlignment.hasOwnProperty(value) && HTMLArea._hasClass(el, blockElements.useClass[this.convertAlignment[value]])) {
+					selected = value;
+					break;
 				}
-				if (val != 'none') HTMLArea._addClass(element,val);
-				break;
 			}
+		} else {
+			selected = el ? el.style.verticalAlign : "";
 		}
-		if (convertCellType) {
-			var newCell = dialog.editor._doc.createElement(newCellType), p = element.parentNode, a, attrName, name;
-			var attrs = element.attributes;
-			for (var i = attrs.length; --i >= 0 ;) {
-				a = attrs.item(i);
-				attrName = a.nodeName;
-				name = attrName.toLowerCase();
-					// IE5.5 reports wrong values. For this reason we extract the values directly from the root node.
-				if (typeof(element[attrName]) != "undefined" && name != "style" && !/^on/.test(name)) {
-					if (element[attrName]) newCell.setAttribute(attrName, element[attrName]);
-				} else {
-					if (a.nodeValue) newCell.setAttribute(attrName, a.nodeValue);
+		(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
+		var ul = doc.createElement("ul");
+		fieldset.appendChild(ul);
+		var li = doc.createElement("li");
+		ul.appendChild(li);
+		select = TableOperations.buildSelectField(doc, li, "f_st_textAlign", "Text alignment:", "fr", "", "Horizontal alignment of text within cell", options, values, new RegExp((selected ? selected : "not set"), "i"));
+		
+		var li = doc.createElement("li");
+		ul.appendChild(li);
+		selected = el ? el.style.verticalAlign : "";
+		(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
+		select = TableOperations.buildSelectField(doc, li, "f_st_vertAlign", "Vertical alignment:", "fr", "", "Vertical alignment of content within cell", ["Not set", "Top", "Middle", "Bottom", "Baseline"], ["not set", "top", "middle", "bottom", "baseline"], new RegExp((selected ? selected : "not set"), "i"));
+		content.appendChild(fieldset);
+	},
+	
+	buildBordersFieldset : function (w, doc, editor, el, content, fieldsetClass) {
+		var nodeName = el ? el.nodeName.toLowerCase() : "table";
+		var select;
+		var selected;
+		var borderFields = [];
+		function setBorderFieldsVisibility(value) {
+			for (var i = 0; i < borderFields.length; ++i) {
+				var borderFieldElement = borderFields[i];
+				borderFieldElement.style.visibility = value ? "hidden" : "visible";
+				if (!value && (borderFieldElement.nodeName.toLowerCase() == "input")) {
+					borderFieldElement.focus();
+					borderFieldElement.select();
 				}
 			}
-				// In IE, the above fails to update the classname and style attributes.
-			if (HTMLArea.is_ie) {
-				if (element.style.cssText) newCell.style.cssText = element.style.cssText;
-				if (element.className) {
-					newCell.setAttribute("className", element.className);
-				} else { 
-					newCell.className = element.className;
-					newCell.removeAttribute("className");
+		};
+		var fieldset = doc.createElement("fieldset");
+		fieldset.className = fieldsetClass;
+		TableOperations.insertLegend(doc, fieldset, "Frame and borders");
+		TableOperations.insertSpace(doc, fieldset);
+			// Gecko reports "solid solid solid solid" for "border-style: solid".
+			// That is, "top right bottom left" -- we only consider the first value.
+		var f_st_borderWidth = el ? TableOperations.getLength(el.style.borderWidth) : ((this.properties && this.properties.borderWidth && this.properties.borderWidth.defaultValue) ? this.properties.borderWidth.defaultValue : "");
+		selected = el ? el.style.borderStyle : ((this.properties && this.properties.borderWidth) ? ((this.properties.borderStyle && this.properties.borderStyle.defaultValue) ? this.properties.borderStyle.defaultValue : "solid") : "");
+		(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
+		selectBorderStyle = TableOperations.buildSelectField(doc, fieldset, "f_st_borderStyle", "Border style:", "fr", "floating", "Border style", ["Not set", "No border", "Dotted", "Dashed", "Solid", "Double", "Groove", "Ridge", "Inset", "Outset"], ["not set", "none", "dotted", "dashed", "solid", "double", "groove", "ridge", "inset", "outset"], new RegExp((selected ? selected : "not set"), "i"));
+		selectBorderStyle.onchange = function() { setBorderFieldsVisibility(this.value == "none"); };
+		this.removeOptions(selectBorderStyle, "f_st_borderStyle");
+		TableOperations.buildInput(doc, fieldset, "f_st_borderWidth", "Border width:", "Border width", "pixels", "5", f_st_borderWidth, "fr", "floating", "postlabel", borderFields);
+		TableOperations.insertSpace(doc, fieldset, borderFields);
+		
+		if (nodeName == "table") {
+			TableOperations.buildColorField(w, doc, editor, fieldset, "", "Color:", "fr", "colorButton", (el ? el.style.borderColor : ""), "borderColor", borderFields);
+			var label = doc.createElement("label");
+			label.className = "fl-borderCollapse";
+			label.htmlFor = "f_st_borderCollapse";
+			label.innerHTML = "Collapsed borders";
+			fieldset.appendChild(label);
+			borderFields.push(label);
+			var input = doc.createElement("input");
+			input.className = "checkbox";
+			input.type = "checkbox";
+			input.name = "f_st_borderCollapse";
+			input.id = "f_st_borderCollapse";
+			input.defaultChecked = el ? /collapse/i.test(el.style.borderCollapse) : false;
+			input.checked = input.defaultChecked;
+			fieldset.appendChild(input);
+			borderFields.push(input);
+			TableOperations.insertSpace(doc, fieldset, borderFields);
+			select = TableOperations.buildSelectField(doc, fieldset, "f_frames", "Frames:", "fr", "floating", "Specifies which sides should have a border", ["Not set", "No sides", "The top side only", "The bottom side only", "The top and bottom sides only", "The right and left sides only", "The left-hand side only", "The right-hand side only", "All four sides"], ["not set", "void", "above", "below", "hsides", "vsides", "lhs", "rhs", "box"], new RegExp(((el && el.frame) ? el.frame : "not set"), "i"), borderFields);
+			TableOperations.insertSpace(doc, fieldset, borderFields);
+			select = TableOperations.buildSelectField(doc, fieldset, "f_rules", "Rules:", "fr", "floating", "Specifies where rules should be displayed", ["Not set", "No rules", "Rules will appear between rows only", "Rules will appear between columns only", "Rules will appear between all rows and columns"], ["not set", "none", "rows", "cols", "all"], new RegExp(((el && el.rules) ? el.rules : "not set"), "i"), borderFields);
+		} else {
+			TableOperations.insertSpace(doc, fieldset, borderFields);
+			TableOperations.buildColorField(w, doc, editor, fieldset, "", "Color:", "fr", "colorButton", (el ? el.style.borderColor : ""), "borderColor", borderFields);
+		}
+		setBorderFieldsVisibility(selectBorderStyle.value == "none");
+		TableOperations.insertSpace(doc, fieldset);
+		content.appendChild(fieldset);
+	},
+	
+	removeOptions : function(select, property) {
+		if (this.properties && this.properties[property] && this.properties[property].removeItems) {
+			for (var i = select.options.length; --i >= 0;) {
+				if (this.properties[property].removeItems.indexOf(select.options[i].value) != -1) {
+					if (select.options[i].value != select.value) {
+						select.options[i] = null;
+					}
 				}
 			}
-			while (element.firstChild) newCell.appendChild(element.firstChild);
-			p.insertBefore(newCell, element);
-			p.removeChild(element);
-			dialog.editor.selectNodeContents(newCell, false);
 		}
-		dialog.editor.updateToolbar();
-	});
-};
+	}
+});
 
 TableOperations.getLength = function(value) {
 	var len = parseInt(value);
